<?php

/**
 *
 * @package acp
 * @version $Id$
 * @copyright (c) 2007 phpBB Group 
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License 
 *
 */
/**
 * @ignore
 */
if (!defined('IN_PHPBB')) {
    exit;
}

/**
 * @package acp
 */
class acp_phpbbsecurity {

    var $action;
    var $u_action;

    function main($id, $mode) {
        global $user, $auth, $template, $phpEx, $db, $config;
        global $phpbb_admin_path, $phpbb_root_path;

        $user->add_lang('mods/phpbbsecurity'); 
        $this->tpl_name = 'acp_phpbbsecurity';
        $this->page_title = 'ACP_PHPBBSECURITY';

        $username	= utf8_normalize_nfc(request_var('username', '', true));
	$user_id	= request_var('u', 0);
        $action		= request_var('action', '');
        
        $submitchangepassword = request_var('submituser', '', true) ? true : false;
        $submitpasschecker = request_var('submitsc', '', true) ? true : false;
        
        include($phpbb_root_path . 'includes/functions_phpbbsecurity.' . $phpEx);
        
        switch ($mode) {
            case 'index':
                obtener_versiones();
                /* COMPROBACIONES GENERALES */
                $estado_debug = comprobar_debug();
                $estado_captcha = (isset($config['enable_confirm'])) ? $config['enable_confirm'] : false;
                $estado_htaccess = comprobar_htaccess();
                if($submitpasschecker){
                    set_config('phpbbsps_enable', request_var('phpbbsps_enable', 0));
                    set_config('enable_confirm', request_var('enable_confirm', 0));
                    trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
                }


                $template->assign_vars(array(
                'PHPBBSPS_ENABLE'      => (isset($config['phpbbsps_enable'])) ? $config['phpbbsps_enable'] : false,    
                'PHPBBS_CD'            => $estado_debug,
                'PHPBBS_CAPTCHA'       => $estado_captcha,
                'PHPBBS_HTACCESS'      => $estado_htaccess,
                'PAGINA_CAPTCHA'       => append_sid($phpbb_admin_path.'index.'.$phpEx, 'i=captcha&amp;mode=visual'),
                'PAGINA_HTACCESS'      => append_sid($phpbb_admin_path.'index.'.$phpEx, 'i=phpbbsecurity&amp;mode=.htaccess'),
                'MAS_OPCIONES'         => append_sid($phpbb_admin_path.'index.'.$phpEx, 'i=board&amp;mode=security'),
                ));

               
                break;
            
            case 'file_scanner':
                comprobar_raiz();
                break;
            
            case 'chmod_permissions':
                permisos_chmod();
                break;
                
             case 'password_strong':
                 /* Mucha parte es realizada por passgenerator.js */
                
                /* Si no se enviaron datos Crea el formulario*/
                if (!$username && !$user_id)
		{
			$template->assign_vars(array(
				'U_ACTION'		=> $this->u_action,
				'S_SELECT_USER'		=> true,
				'U_FIND_USERNAME'	=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=select_user&amp;field=username&amp;select_single=true'),
                        ));
		}
                
                /* Recogemos las variables */
                $data = array(
                        'new_password'		=> request_var('new_password', '', true),
                        'password_confirm'	=> request_var('new_password_confirm', '', true),
                );
                /* Si el formulario ha sido enviado */
                if($submitchangepassword){
                    if($data['new_password'] == $data['password_confirm']){

                        $username = request_var('username', '', true);

                        /* Si el user_id no ha sido creado, lo saca a partir del username y si no puede (usuario no existe) da un error */
                        if (!$user_id)
                        {
                                $sql = 'SELECT user_id
                                        FROM ' . USERS_TABLE . "
                                        WHERE username_clean = '" . $db->sql_escape(utf8_clean_string($username)) . "'";
                                $result = $db->sql_query($sql);
                                $user_id = (int) $db->sql_fetchfield('user_id');
                                $db->sql_freeresult($result);

                                if (!$user_id)
                                {
                                        trigger_error($user->lang['NO_USER'] . adm_back_link($this->u_action), E_USER_WARNING);
                                }

                        }

                        /* Generamos user_row para acciones posteriores (Comprobar si es fundador, etc) si no se genera da error */
                        $sql = 'SELECT u.*, s.*
                                FROM ' . USERS_TABLE . ' u
                                        LEFT JOIN ' . SESSIONS_TABLE . ' s ON (s.session_user_id = u.user_id)
                                WHERE u.user_id = ' . $user_id . '
                                ORDER BY s.session_time DESC';
                        $result = $db->sql_query_limit($sql, 1);
                        $user_row = $db->sql_fetchrow($result);
                        $db->sql_freeresult($result);

                        // Prevent normal users/admins change/view founders if they are not a founder by themselves
                        if ($user->data['user_type'] != USER_FOUNDER && $user_row['user_type'] == USER_FOUNDER)
                        {
                                trigger_error($user->lang['NOT_FOUNDER_USER'] . adm_back_link($this->u_action), E_USER_WARNING);
                        }

                        /* Si el formulario ha sido enviado y la password ha sido recibida crea un array con los cambios que se van a hacer
                         * da parte al log, y ejecuta ese array en una consulta sql
                         */
                        if (isset($data['new_password'])){

                                $sql_ary = array(
                                        'user_password'		=> phpbb_hash($data['new_password']),
                                        'user_passchg'		=> time(),
                                        'user_pass_convert'	=> 0,
                                );
                                $user->reset_login_keys($user_id);
                                add_log('user', $user_id, 'LOG_USER_NEW_PASSWORD', $user_row['username']);

                                if (sizeof($sql_ary))
                                {
                                        $sql = 'UPDATE ' . USERS_TABLE . '
                                                SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
                                                WHERE user_id = ' . $user_id;
                                        $db->sql_query($sql);
                                        /* Enviamos un e-mail al usuario */
                                        if (!class_exists('messenger'))
                                        {
                                            include( $phpbb_root_path . 'includes/functions_messenger.' .$phpEx );
                                        }                
                                        $messenger = new messenger(false);
                                        $messenger->to($user_row['user_email'], $user_row['username']);
                                        $messenger->from($config['board_email']);
                                        $messenger->template('phpbbsecurity_passchange', $user_row['user_lang']);
                                        $messenger->assign_vars(array(
                                                'USER_NAME' => $user_row['username'],
                                                'SITENAME' => $config['sitename'], 
                                                'NEW_PASSWORD'  => $data['new_password'],
                                        ));
                                        $messenger->send(); 
                                }
                                add_log('admin', 'LOG_USER_USER_UPDATE', $username);
                                $info = $user->lang['CONFIG_UPDATED'] . adm_back_link($this->action);
                                trigger_error($info);
                            }
                    }
                    else{
                        trigger_error($user->lang['NOT_SAME_PASS'] . adm_back_link($this->u_action), E_USER_WARNING);
                    }
                }
                break;
            case ".htaccess":
                $htaccess = obtener_htaccess();
                $htaccessnecesario = htaccess_necesario($htaccess);
                $template->assign_vars(array(
                        'HTACCESS_ACTUAL'		=> htmlentities($htaccess),
                        'HTACCESS_NECESARIO'             => htmlentities($htaccessnecesario),
                ));
                break;   
        }
        
            $template->assign_vars(array(
                'S_MODE' => $mode,
            ));
    }

}

?>