<?php
/**
*
* @package phpBB3
* @version $Id: functions_phpbbsecurity.php 240 2011-16-07 Juanla $
* @copyright (c) 2008,2009 Juanla
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/* 
 * Obtenemos la versin del Mod, la versin actual de phpBB 
 * y la ltima versin disponible de phpBB
 */
function obtener_versiones(){
    global $template, $config;
                    // Obtener ltima versin de PhpBB
                    $errstr = '';
                    $errno = 0;

                    $info = obtain_latest_version_info(request_var('versioncheck_force', false), true);

                    if ($info === false)
                    {
                            trigger_error('VERSIONCHECK_FAIL', E_USER_WARNING);
                    }

                    $info = explode("\n", $info);
                    $latest_version = trim($info[0]);
                    $color = "";
                    if($latest_version == $config['version']){
                        $color = "green";
                    }else{ $color = "red"; }
                    //Variables a mandar
                   $template->assign_vars(array(
                    'VERSION_PHPBBSECURITY' => '1.0.0 [BETA]',
                    'LATEST_VERSION'	=> $latest_version,
                    'CURRENT_VERSION'	=> "<span style=\"color:$color\">".$config['version']."</span>",
                   ));
}
/* Comprobar .htaccess seguro */
function comprobar_htaccess(){
    global $phpbb_root_path;
    $htaccess = file_get_contents($phpbb_root_path.'/.htaccess');
    if(stristr($htaccess, ".htaccess from phpBBsecurity")){
        return 1;
    }else{return 0;}
}

/*COMPROBAMOS EL ESTADO DEL DEBUG*/
function comprobar_debug(){
    if(defined('DEBUG') && defined('DEBUG_EXTRA')){
        return 1;
    }elseif(defined('DEBUG') || defined('DEBUG_EXTRA')){
        return 1;
    }else{
        return 0;
    }
}

/* Comprobar archivo para ver si puede ser peligroso */
function comprobar_archivo($archivo){
    if(stristr($archivo, "install") || stristr($archivo, ".sql") || stristr($archivo, "cookie.php")){return 1;}
    else {return 0;}     
}
/* Comprobamos los archivos que hay en la raz */
function comprobar_raiz(){
    global $template, $phpbb_root_path;

    $archivos = array();
    /* Leer todos los archivos */
    $directorio=dir($phpbb_root_path);
    $cont_archivos = 0;
    while ($archivo = $directorio->read())
    {
        if($archivo!="." || $archivo!=".."){
            $archivos[$cont_archivos] = $archivo;
            $cont_archivos = $cont_archivos +1;
        }      
    }
    $directorio->close();
    /* Los mandamos a la plantilla si son "peligrosos" */
    for ($i = 0; $i < sizeof($archivos); $i++)
    {
       $estado = comprobar_archivo($archivos[$i]);
       if($estado == 1){
           $template->assign_block_vars('listaarchivos', array(
               "ARCHIVO" => "root/".$archivos[$i],
               "PARIDAD" => $i%2,
           ));
       }
    }
}

function permisos_chmod(){
    global $phpbb_root_path,$template;
    $archivos = array();
    $directorios = array();
    /* Leer todos los archivos de un directorio */
    $directorio=dir($phpbb_root_path);
    $cont_archivos = 0;
    $cont_dir = 0;
    while ($archivo = $directorio->read())
    {
        if($archivo!="." || $archivo!=".."){
            if(stristr($archivo, ".")){
                $archivos[$cont_archivos] = $archivo;
                $cont_archivos = $cont_archivos +1;
            }else{
                $directorios[$cont_dir] = $archivo;
                $cont_dir = $cont_dir +1;
            }
        }      
    }
    $directorio->close();
    /* Limpiamos la cach de permisos */
    clearstatcache();
    /* Asignamos la subcarpeta de avatares */
    $color = "";
    $permisos = substr(decoct(@fileperms($phpbb_root_path."images/avatars")),-3);
    if($permisos == "777"){ $color="#81F781"; }else{ $color="#F78181"; }
    $template->assign_vars(array(
        "ARCHIVOI" => "images/avatars",
        "PARIDADI" => "1",
        "PERMISOI" => $permisos,
        "NECESARIOI" => '777',
        "COLORI"  => $color,
       ));

    for ($i = 0; $i < sizeof($archivos); $i++)
    {
         if($archivos[$i]=="." || $archivos[$i]==".."){}else{
           $permisos = substr(decoct(@fileperms($phpbb_root_path.$archivos[$i])),-3);
           $color = "";
           if($permisos == "644"){ $color="#81F781"; }else{ $color="#F78181"; }
           $template->assign_block_vars('chmod_archivos', array(
               "ARCHIVO" => $archivos[$i],
               "PARIDAD" => $i%2,
               "PERMISO" => $permisos,
               "NECESARIO" => '644',
               "COLOR"  => $color,
           ));
         }

    }
    for ($i = 0; $i < sizeof($directorios); $i++)
    {
        //if($directorios[$i]!="." || $directorios[$i]!=".."){
           $permisos = substr(decoct(@fileperms($phpbb_root_path.$directorios[$i])),-3);
           $color = "";
           if($permisos == "755"){ $color="#81F781"; }else{ $color="#F78181"; }
           $template->assign_block_vars('chmod_directorios', array(
               "ARCHIVO" => $directorios[$i],
               "PARIDAD" => $i%2,
               "PERMISO" => $permisos,
               "NECESARIO" => '755',
               "COLOR"  => $color,
           ));
        //}
    }
}

/* Obtener el .htaccess */
function obtener_htaccess(){
    global $phpbb_root_path,$template;
    $htaccess = file_get_contents($phpbb_root_path.'/.htaccess');
    return $htaccess;
}

/* Generar el .htaccess nuevo */
function htaccess_necesario($htaccess){
    global $config;
    $htaccessantiguo = $htaccess;
    if(stristr($htaccessantiguo, ".htaccess from phpBBsecurity")){
        $htaccessnuevo = $htaccessantiguo;
        return $htaccessnuevo;
    }else{
        $htaccessnuevo = $htaccessantiguo;

        $htaccessnuevo .= "\n#.htaccess from phpBBsecurity\n";
        //Esconder errores del servidor
        $htaccessnuevo .= "\nErrorDocument 401 /error.php?servererror=401\n";
        $htaccessnuevo .= "ErrorDocument 402 /error.php?servererror=402\n";
        $htaccessnuevo .= "ErrorDocument 403 /error.php?servererror=403\n";
        $htaccessnuevo .= "ErrorDocument 404 /error.php?servererror=404\n";
        $htaccessnuevo .= "ErrorDocument 405 /error.php?servererror=405\n";

        //Evitar escaneos y ataques SQLi/XSS
        $htaccessnuevo .= "\nRewriteEngine On\n";
        $htaccessnuevo .= "Options +FollowSymLinks\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^$ [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^(-|\.|') [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^(.*)(<|>|%3C|%3E)(.*) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^(java|curl|wget)(.*) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^(.*)(libwww-perl|libwwwperl|snoopy|curl|wget|winhttp|python|nikto|scan|clshttp|archiver|loader|email|harvest|fetch|extract|grab|miner|suck|reaper|leach)(.*) [NC,OR]\n";

        $htaccessnuevo .= "RewriteCond %{REQUEST_URI} ^(/,|/;|/<|/>|/'|/%2C|/%3C|/%3E|/%27|/////) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_REFERER} ^(.*)(%00|%08|%09|%0A|%0B|%0C|%0D|%0E|%0F|%2C|<|>|'|%3C|%3E|%26%23|%27|%60)(.*) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{QUERY_STRING} ^(.*)(%00|%08|%09|%0A|%0B|%0C|%0D|%0E|%0F|%2C|%3C|%3E|%27|%26%23|%60)(.*) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{QUERY_STRING} ^(.*)('|-|<|>|,|/|\\|\.a|\.c|\.t|\.d|\.p|\.i|\.e|\.j)(.*) [NC,OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_COOKIE} ^(.*)(<|>|'|%3C|%3E|%27)(.*) [NC]\n";

        // Denegar el acceso a robots, browser "malos"
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^Anarchie [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^ASPSeek [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^attach [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^autoemailspider [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^Xaldon\ WebSpider [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^Xenu [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^Zeus.*Webster [OR]\n";
        $htaccessnuevo .= "RewriteCond %{HTTP_USER_AGENT} ^Zeus\n";

        //Evitar que usuarios navegen por directorios
        $htaccessnuevo .= "Options All -Indexes\n";
        $htaccessnuevo .= "IndexIgnore *\n";
        //Email
        $htaccessnuevo .= "ServerSignature EMail\n";
        $htaccessnuevo .= "SetEnv SERVER_ADMIN ".$config['board_email'];
    }
    //Devolvemos nuevo htaccess
    return $htaccessnuevo;
}
?>